/*

Namazu.xs

# Copyright (C) 1999,2000,2001,2002 NOKUBI Takatsugu All rights reserved.
# This is free software with ABSOLUTELY NO WARRANTY.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA

$Id: Namazu.xs,v 1.19 2002/06/19 10:01:10 knok Exp $

*/

#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stdio.h>
#include <namazu/libnamazu.h>
#include <namazu/codeconv.h>
#include <namazu/field.h>
#include <namazu/hlist.h>
#include <namazu/idxname.h>
#include <namazu/parser.h>
#include <namazu/re.h>
#include <namazu/search.h>
#include <namazu/util.h>
#include <namazu/wakati.h>
#ifdef __cplusplus
}
#endif

/* for old perl (< 5.004_04?) */
#if !defined(PL_na) && defined(na)
#define PL_na na
#endif
#if !defined(PL_sv_undef) && defined(sv_undef)
#define PL_sv_undef sv_undef
#endif

MODULE = Search::Namazu		PACKAGE = Search::Namazu

PROTOTYPES: DISABLE

void
call_search_main(query)
	SV *query

	PPCODE:
		char *qstr;
		char cqstr[BUFSIZE * 2];
		int i;
		AV *retar;
		NmzResult hlist;
		char result[4][BUFSIZE];

		qstr = SvPV(query, PL_na);
		strcpy(cqstr, qstr);
		retar = newAV();
		hlist = nmz_search(cqstr);
		for (i = 0; i < hlist.num; i ++) {
			SV *ohlist = perl_eval_pv("new Search::Namazu::Result", TRUE);
			dSP;
			nmz_get_field_data(hlist.data[i].idxid, hlist.data[i].docid, "uri", result[0]);
			nmz_get_field_data(hlist.data[i].idxid, hlist.data[i].docid, "summary", result[1]);
			nmz_get_field_data(hlist.data[i].idxid, hlist.data[i].docid, "title", result[2]);
			nmz_get_field_data(hlist.data[i].idxid, hlist.data[i].docid, "author", result[3]);
			ENTER;
			SAVETMPS;
			PUSHMARK(SP);
			PUSHs(ohlist);
			PUSHs(sv_2mortal(newSViv(hlist.data[i].score)));
			PUSHs(sv_2mortal(newSVpv(result[0], strlen(result[0]))));
			PUSHs(sv_2mortal(newSViv(hlist.data[i].date)));
			PUSHs(sv_2mortal(newSViv(hlist.data[i].rank)));
			PUSHs(sv_2mortal(newSVpv(result[1], strlen(result[1]))));
			PUSHs(sv_2mortal(newSVpv(result[2], strlen(result[2]))));
			PUSHs(sv_2mortal(newSVpv(result[3], strlen(result[3]))));
			PUTBACK;
			perl_call_method("set", G_DISCARD);
			av_push(retar, ohlist);
			FREETMPS;
			LEAVE;
		}
		nmz_free_hlist(hlist);
#if ! defined(PERL_VERSION)
		{ /* workaround for only one result */
			SV *ohlist = perl_eval_pv("new Search::Namazu::Result", TRUE);
			XPUSHs(ohlist);
		}
#endif /* PERL_VERSION */
		for (i = 0; i < hlist.num; i ++) {
			XPUSHs(av_pop(retar));
		}
		nmz_free_internal();

int
nmz_addindex(index)
	SV *index

	PREINIT:
		char *tmp;

	CODE:
		tmp = SvPV(index, PL_na);
		RETVAL = nmz_add_index(tmp);

	OUTPUT:
		RETVAL

void
nmz_sortbydate()
	CODE:
		nmz_set_sortmethod(SORT_BY_SCORE);

void
nmz_sortbyscore()
	CODE:
		nmz_set_sortmethod(SORT_BY_DATE);

void
nmz_sortbyfield()
	CODE:
		nmz_set_sortmethod(SORT_BY_FIELD);

void
nmz_descendingsort()
	CODE:
		nmz_set_sortorder(ASCENDING);

void
nmz_ascendingsort()
	CODE:
		nmz_set_sortorder(DESCENDING);

int
nmz_setlang(lang)
	SV *lang

	PREINIT:
		char *tmp;

	CODE:
		tmp = SvPV(lang, PL_na);
		RETVAL = nmz_set_lang(tmp);

	OUTPUT:
		RETVAL
